package com.gxzc.zen

import com.gxzc.zen.common.util.FileUtil
import org.apache.commons.io.FilenameUtils
import org.junit.Test
import java.nio.ByteBuffer


/**
 *
 * @author NorthLan
 * @date 2018/5/24
 * @url https://noahlan.com
 */
class TestFileChunks {

    /**
     * 测试文件md5生成
     * 选取文件 头尾chunk 和 最后修改日期 结合生成md5
     * chunkSize = 10 * 1024 * 1024 = 10MB
     */
    @Test
    fun testFileChunkMd5() {
        val chunkSize = 10 * 1024 * 1024
        val path = "D:\\data\\HBuilder.8.9.1.windows.zip"
        println(FileUtil.md5HeadTail(path, chunkSize))
    }

    @Test
    fun longLength() {
        println(java.lang.Long.SIZE / 8)
    }

    @Test
    fun longToBytes() {
        val buffer = ByteBuffer.allocate(8)
        buffer.putLong(1501841794418L)
//        buffer.flip()
        val byteArray = buffer.array()
        byteArray.reverse()
        buffer.clear()
    }

    @Test
    fun testRegex() {
        val a = "C:\\Users\\Test\\a"
        val b = "\\Users\\Test\\b"
        val c = "/Users/Test/c"
        val d = "//Users/Test/d"

        val regex = "^[\\\\/]+"

        println(a.replace(Regex(regex), ""))
        println(b.replace(Regex(regex), ""))
        println(c.replace(Regex(regex), ""))
        println(d.replace(Regex(regex), ""))

        println(getDestFilePath("niubi.pdf", "niubi.pdf", null))

        val e = "D:\\data\\\\a.exe"
        println(FilenameUtils.normalize(e))
    }

    /**
     * 生成 文件夹结构
     */
    fun getDestFilePath(filename: String, relativePath: String, repath: String?): String {
        return repath?.replace(Regex("^[\\\\/]+"), "")?.replace("/", FILE_SEPARATOR)?.replace("\\", FILE_SEPARATOR)
                ?: relativePath.replace(filename, "").replace("/", FILE_SEPARATOR).replace("\\", FILE_SEPARATOR)
    }

    private val FILE_SEPARATOR = System.getProperty("file.separator") // 适配操作系统的文件路径

    @Test
    fun testFor() {
        for (i in 1..10) {
            println(i)
        }
    }

    @Test
    fun testExt() {
        println(FilenameUtils.getExtension("skldjfklsjdf"))
        println(FilenameUtils.getExtension("skldjfklsjdf.exe"))
    }
}